diff --git a/src/main/java/net/minecraft/client/input/InputHandler.java b/src/main/java/net/minecraft/client/input/InputHandler.java
index feeadfe63..cb36ff0fc 100644
--- a/src/main/java/net/minecraft/client/input/InputHandler.java
+++ b/src/main/java/net/minecraft/client/input/InputHandler.java
@@ -1,23 +1,20 @@
 package net.minecraft.client.input;
 
-import java.util.ArrayList;
-import java.util.List;
-
+import net.minecraft.client.input.glfw.GlfwGamepad;
+import net.minecraft.client.input.glfw.GlfwJoystick;
+import org.lwjgl.glfw.GLFW;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 
-import net.java.games.input.Component;
-import net.java.games.input.Controller;
-import net.java.games.input.Controller.Type;
-import net.java.games.input.ControllerEnvironment;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.ControllerInput;
 
 public abstract class InputHandler {
-	
-	public static List<ControllerInput> controllers; 
+	private static Minecraft minecraft;
+	public static ControllerInput[] controllers = new ControllerInput[GLFW.GLFW_JOYSTICK_LAST + 1];
 	
 	public static void init(Minecraft minecraft) throws Exception{
+		InputHandler.minecraft = minecraft;
     	System.out.println("Creating Keyboard & Mouse");
     	Keyboard.create();
     	Mouse.create();
@@ -32,39 +29,89 @@ public abstract class InputHandler {
         }else {
         	System.err.println("JInput is disabled!");
         }
+		try {
+			initLWJGL3(minecraft);
+		} catch (Throwable e) {
+			System.err.println("Could not initialize SDL2.");
+			e.printStackTrace();
+		}
+	}
+
+	public static void poll() {
+		for (int i = GLFW.GLFW_JOYSTICK_1; i < GLFW.GLFW_JOYSTICK_LAST; i++) {
+			if (controllers[i] != null) {
+				if (!controllers[i].getController().isPresent()) {
+					disconnected(controllers[i]);
+					controllers[i] = null;
+				} else {
+					controllers[i].getController().poll();
+				}
+			} else {
+				if (GLFW.glfwJoystickPresent(i)) {
+					GlfwGamepad gamepad = new GlfwJoystick(i).intoGamepad();
+					if (gamepad != null) {
+						ControllerInput input = new ControllerInput(minecraft, gamepad);
+						controllers[i] = input;
+						connected(input);
+					}
+				}
+			}
+		}
+	}
+
+	private static void connected(ControllerInput controller) {
+		System.out.println("Controller connected: " + controller.getGUID());
+		minecraft.controllerInput = getController(controller.getGUID());
+	}
+
+	private static void disconnected(ControllerInput controller) {
+		System.out.println("Controller disconnected: " + controller.getGUID());
+		if(minecraft.controllerInput == controller) {
+			minecraft.setInputType(InputType.KEYBOARD);
+			minecraft.controllerInput = null;
+		}
+	}
+
+	public static void initLWJGL3(Minecraft minecraft) throws Throwable {
+		int found = 0;
+		for (int i = GLFW.GLFW_JOYSTICK_1; i < GLFW.GLFW_JOYSTICK_LAST; i++) {
+			if (GLFW.glfwJoystickPresent(i)) {
+				GlfwGamepad gamepad = new GlfwJoystick(i).intoGamepad();
+				if (gamepad != null) {
+					ControllerInput input = new ControllerInput(minecraft, gamepad);
+					controllers[i] = input;
+					found++;
+				}
+			}
+		}
+		System.out.println(found + " controllers found!");
 	}
 	
 	public static void initJInput(Minecraft minecraft) throws Throwable{
-		Controller[] devices = getControllers();
+		net.java.games.input.Controller[] devices = getControllers();
 		
 		if(devices == null) {
 			System.err.println("Could not get devices!");
 			return;
 		}
 		
-		System.out.println(devices.length + " Devices found!");
+		System.out.println(devices.length + " devices found!");
 		
-		List<ControllerInput> controllerList = new ArrayList<>();
-		for(Controller controller : devices) {
-			if(controller.getType() == Type.GAMEPAD) {
-				controllerList.add(new ControllerInput(minecraft, controller));
-			}
-			if(controller.getType() == Type.MOUSE) {
+		for(net.java.games.input.Controller controller : devices) {
+			if(controller.getType() == net.java.games.input.Controller.Type.MOUSE) {
 				minecraft.mouseInput.addMouse(controller);
 			}
 		}
-		
-		controllers = controllerList;
 	}
 	
-	public static Controller[] getControllers() throws Throwable{
-		return ControllerEnvironment.getDefaultEnvironment().getControllers();
+	public static net.java.games.input.Controller[] getControllers() throws Throwable{
+		return net.java.games.input.ControllerEnvironment.getDefaultEnvironment().getControllers();
 	}
 	
-	public static ControllerInput getController(String name) {
+	public static ControllerInput getController(String guid) {
 		try {
 			for(ControllerInput controllerInput : controllers) {
-				if(controllerInput.getController().getName().equalsIgnoreCase(name)) {
+				if(controllerInput.getGUID().equalsIgnoreCase(guid)) {
 					return controllerInput;
 				}
 			}
@@ -72,13 +119,12 @@ public abstract class InputHandler {
 		return null;
 	}
 	
-	public static Component getComponent(Controller controller, String id) {
+	public static net.java.games.input.Component getComponent(net.java.games.input.Controller controller, String id) {
 		try {
-			for(Component component : controller.getComponents()) {
+			for(net.java.games.input.Component component : controller.getComponents()) {
 				if(component.getIdentifier().toString().equalsIgnoreCase(id)) return component;
 			}
 		}catch (Exception e) {}
 		return null;
 	}
-	
 }
diff --git a/src/main/java/net/minecraft/client/input/PlayerInput.java b/src/main/java/net/minecraft/client/input/PlayerInput.java
index 9afae5192..0d2bbe04a 100644
--- a/src/main/java/net/minecraft/client/input/PlayerInput.java
+++ b/src/main/java/net/minecraft/client/input/PlayerInput.java
@@ -2,7 +2,7 @@ package net.minecraft.client.input;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 
 public class PlayerInput {
@@ -86,7 +86,7 @@ public class PlayerInput {
 		}
 	}
 
-	public void tick(EntityPlayer entityplayer) {
+	public void tick(Player entityplayer) {
 		moveStrafe = 0.0f;
 		moveForward = 0.0f;
 		jump = false;
diff --git a/src/main/java/net/minecraft/client/input/controller/Button.java b/src/main/java/net/minecraft/client/input/controller/Button.java
index 59c787b3a..34844a81e 100644
--- a/src/main/java/net/minecraft/client/input/controller/Button.java
+++ b/src/main/java/net/minecraft/client/input/controller/Button.java
@@ -1,12 +1,10 @@
 package net.minecraft.client.input.controller;
 
-import net.java.games.input.Component;
-
 public class Button implements IButton{
 	
 	public final String name;
 	
-	public Component component;
+	public int button;
 	public IButtonListener buttonListener;
 	
 	private boolean pressed = false;
@@ -17,9 +15,9 @@ public class Button implements IButton{
 	
 	private int holdTime;
 	
-	public Button(String name, Component component, IButtonListener buttonListener) {
+	public Button(String name, int button, IButtonListener buttonListener) {
 		this.name = name;
-		this.component = component;
+		this.button = button;
 		this.buttonListener = buttonListener;
 	}
 
@@ -43,7 +41,7 @@ public class Button implements IButton{
 
 	@Override
 	public void update() {
-		boolean p = buttonListener.isPressed(component);
+		boolean p = buttonListener.isPressed(button);
 		if(!p) {
 			this.cancelled = false;
 			this.holdTime = 0;
diff --git a/src/main/java/net/minecraft/client/input/controller/ControllerInput.java b/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
index 9a32cb29b..b9433474a 100644
--- a/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
+++ b/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
@@ -1,184 +1,333 @@
 package net.minecraft.client.input.controller;
 
 import com.b100.utils.ReflectUtils;
-import net.java.games.input.Component;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiContainer;
-import net.minecraft.client.gui.GuiCrafting;
-import net.minecraft.client.gui.GuiFurnace;
-import net.minecraft.client.gui.GuiInventory;
-import net.minecraft.client.gui.GuiInventoryCreative;
-import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import net.minecraft.client.input.glfw.GlfwGamepad;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Time;
-import net.minecraft.client.input.InputHandler;
+import org.lwjgl.glfw.GLFW;
 
 public class ControllerInput {
-	
-	public final Minecraft minecraft;
-	
-	private final net.java.games.input.Controller controller;
-	
-	public Joystick joyLeft;
-	public Joystick joyRight;
-
-	public Button buttonA;
-	public Button buttonB;
-	public Button buttonX;
-	public Button buttonY;
-	
-	public Button buttonZL;
-	public Button buttonZR;
-	
-	public Button buttonMinus;
-	public Button buttonPlus;
-	
-	public Button buttonL;
-	public Button buttonR;
-	
-	public DigitalPad digitalPad;
-	
-	public Button[] buttons;
-	public Joystick[] joysticks;
-	
-	public double cursorX;
-	public double cursorY;
-	
-	public final ControllerInventoryHandler craftingGuiHandler = new ControllerInventoryHandler(this);
-	
-	private boolean disconnected = false;
-	
-	public ControllerInput(Minecraft minecraft, net.java.games.input.Controller controller) {
-		this.minecraft = minecraft;
-		this.controller = controller;
-		
-		System.out.println("Controller: "+controller+" Type: "+controller.getType());
-		
-		setup();
-	}
-	
-	public void setup() {
-		Component[] c = controller.getComponents();
-		
-		IButtonListener defaultListener = (comp) -> comp.getPollData() > 0.5f;
-		
-		joyLeft = new Joystick("Analog Left", c[1], c[0], new Button("Left Stick", c[13], defaultListener), minecraft.gameSettings.controllerDeadzoneLeft);
-		joyRight = new Joystick("Analog Right", c[3], c[2], new Button("Right Stick", c[14], defaultListener), minecraft.gameSettings.controllerDeadzoneRight);
-		
-		buttonMinus = new Button("-", comp("6"), defaultListener);
-		buttonPlus = new Button("+", comp("7"), defaultListener);
-		
-		if(!minecraft.gameSettings.controllerSwapAB.value) {
-			buttonA = new Button("A", comp("0"), defaultListener);
-			buttonB = new Button("B", comp("1"), defaultListener);
-		}else {
-			buttonA = new Button("A", comp("1"), defaultListener);
-			buttonB = new Button("B", comp("0"), defaultListener);
-		}
-		
-		if(!minecraft.gameSettings.controllerSwapXY.value) {
-			buttonX = new Button("X", comp("2"), defaultListener);
-			buttonY = new Button("Y", comp("3"), defaultListener);
-		}else {
-			buttonX = new Button("X", comp("3"), defaultListener);
-			buttonY = new Button("Y", comp("2"), defaultListener);
-		}
-		
-		if(minecraft.gameSettings.controllerSwapShoulderButtons.value) {
-			buttonZL = new Button("ZL", comp("4"), defaultListener);
-			buttonZR = new Button("ZR", comp("5"), defaultListener);
-			
-			buttonL = new Button("L", comp("z"), (comp) -> comp.getPollData() > 0.5f);
-			buttonR = new Button("R", comp("z"), (comp) -> comp.getPollData() < -0.5f);
-		}else {
-			buttonL = new Button("ZL", comp("4"), defaultListener);
-			buttonR = new Button("ZR", comp("5"), defaultListener);
-			
-			buttonZL = new Button("L", comp("z"), (comp) -> comp.getPollData() > 0.5f);
-			buttonZR = new Button("R", comp("z"), (comp) -> comp.getPollData() < -0.5f);
-		}
-		
-		digitalPad = new DigitalPad(this, comp("pov"));
-		
-		buttons = ReflectUtils.getAllObjects(ControllerInput.class, Button.class, this);
-		joysticks = ReflectUtils.getAllObjects(ControllerInput.class, Joystick.class, this);
-	}
-	
-	public void moveCursor() {
-		double speed = 300 * Time.delta * (minecraft.gameSettings.controllerMenuSensitivity.value + 0.5f);
-		
-		cursorX += ((Math.pow(joyLeft.getX(), 3.0f) + joyLeft.getX()) / 2.0f) * speed;
-		cursorY += ((Math.pow(joyLeft.getY(), 3.0f) + joyLeft.getY()) / 2.0f) * speed;
-		
-		cursorX = Math.max(cursorX, 0);
-		cursorY = Math.max(cursorY, 0);
-		
-		cursorX = Math.min(cursorX, minecraft.resolution.scaledWidth);
-		cursorY = Math.min(cursorY, minecraft.resolution.scaledHeight);
-	}
-	
-	public net.java.games.input.Controller getController() {
-		return controller;
-	}
-
-	public void update() {
-		if(disconnected || !controller.poll()) {
-			this.disconnected = true;
-			throw new RuntimeException("Controller Disconnected!");
-		}
-		
-		for(int i=0; i < buttons.length; i++) {
-			buttons[i].update();
-		}
-		for(int i=0; i < joysticks.length; i++) {
-			joysticks[i].update();
-		}
-		digitalPad.update();
-	}
-	
-	public Slot getSlotAtCursor(GuiContainer guiContainer) {
-		return getSlotAt((int)cursorX, (int)cursorY, guiContainer);
-	}
-    
+
+    public final Minecraft minecraft;
+
+    private final GlfwGamepad controller;
+
+    public Joystick joyLeft;
+    public Joystick joyRight;
+
+    public Button buttonA;
+    public Button buttonB;
+    public Button buttonX;
+    public Button buttonY;
+
+    public Button buttonLeftTrigger;
+    public Button buttonRightTrigger;
+
+    public Button buttonBack;
+    public Button buttonStart;
+
+    public Button buttonLeftShoulder;
+    public Button buttonRightShoulder;
+
+    public DigitalPad digitalPad;
+
+    public Button[] buttons;
+    public Joystick[] joysticks;
+
+    public double cursorX;
+    public double cursorY;
+
+    private final ControllerType type;
+
+    public final ControllerInventoryHandler craftingGuiHandler = new ControllerInventoryHandler(this);
+
+    private boolean disconnected = false;
+
+    public ControllerInput(Minecraft minecraft, GlfwGamepad controller) {
+        this.minecraft = minecraft;
+        this.controller = controller;
+
+        this.type = ControllerType.fromController(controller);
+
+        setup();
+    }
+
+    public String getGUID() {
+        return controller.getName();
+    }
+
+    public ControllerType getType() {
+        return type;
+    }
+
+    public void setup() {
+        IButtonListener defaultButtonListener = controller::isButtonPressed;
+        IJoystickListener defaultJoystickListener = controller::getAxisValue;
+
+        joyLeft = new Joystick(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_LEFT_X), GLFW.GLFW_GAMEPAD_AXIS_LEFT_X, GLFW.GLFW_GAMEPAD_AXIS_LEFT_Y, defaultJoystickListener, new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_LEFT_THUMB), GLFW.GLFW_GAMEPAD_BUTTON_LEFT_THUMB, defaultButtonListener), minecraft.gameSettings.controllerDeadzoneLeft);
+        joyRight = new Joystick(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_RIGHT_X), GLFW.GLFW_GAMEPAD_AXIS_RIGHT_X, GLFW.GLFW_GAMEPAD_AXIS_RIGHT_Y, defaultJoystickListener, new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_THUMB), GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_THUMB, defaultButtonListener), minecraft.gameSettings.controllerDeadzoneRight);
+
+        buttonBack = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_BACK), GLFW.GLFW_GAMEPAD_BUTTON_BACK, defaultButtonListener);
+        buttonStart = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_START), GLFW.GLFW_GAMEPAD_BUTTON_START, defaultButtonListener);
+
+        if (minecraft.gameSettings.controllerSwapAB.value) {
+            buttonA = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_A), GLFW.GLFW_GAMEPAD_BUTTON_B, defaultButtonListener);
+            buttonB = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_B), GLFW.GLFW_GAMEPAD_BUTTON_A, defaultButtonListener);
+        } else {
+            buttonA = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_A), GLFW.GLFW_GAMEPAD_BUTTON_A, defaultButtonListener);
+            buttonB = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_B), GLFW.GLFW_GAMEPAD_BUTTON_B, defaultButtonListener);
+        }
+
+        if (minecraft.gameSettings.controllerSwapXY.value) {
+            buttonX = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_X), GLFW.GLFW_GAMEPAD_BUTTON_Y, defaultButtonListener);
+            buttonY = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_Y), GLFW.GLFW_GAMEPAD_BUTTON_X, defaultButtonListener);
+        } else {
+            buttonX = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_X), GLFW.GLFW_GAMEPAD_BUTTON_X, defaultButtonListener);
+            buttonY = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_Y), GLFW.GLFW_GAMEPAD_BUTTON_Y, defaultButtonListener);
+        }
+
+        if (minecraft.gameSettings.controllerSwapShoulderButtons.value) {
+            buttonLeftShoulder = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_LEFT_BUMPER), GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_BUMPER, defaultButtonListener);
+            buttonRightShoulder = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_BUMPER), GLFW.GLFW_GAMEPAD_BUTTON_LEFT_BUMPER, defaultButtonListener);
+
+            buttonLeftTrigger = new Button(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_LEFT_TRIGGER), GLFW.GLFW_GAMEPAD_AXIS_RIGHT_TRIGGER, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
+            buttonRightTrigger = new Button(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_RIGHT_TRIGGER), GLFW.GLFW_GAMEPAD_AXIS_LEFT_TRIGGER, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
+        } else {
+            buttonLeftShoulder = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_LEFT_BUMPER), GLFW.GLFW_GAMEPAD_BUTTON_LEFT_BUMPER, defaultButtonListener);
+            buttonRightShoulder = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_BUMPER), GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_BUMPER, defaultButtonListener);
+
+            buttonLeftTrigger = new Button(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_LEFT_TRIGGER), GLFW.GLFW_GAMEPAD_AXIS_LEFT_TRIGGER, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
+            buttonRightTrigger = new Button(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_RIGHT_TRIGGER), GLFW.GLFW_GAMEPAD_AXIS_RIGHT_TRIGGER, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
+        }
+
+        digitalPad = new DigitalPad(
+            new Button("Digital Up", GLFW.GLFW_GAMEPAD_BUTTON_DPAD_UP, defaultButtonListener),
+            new Button("Digital Left", GLFW.GLFW_GAMEPAD_BUTTON_DPAD_LEFT, defaultButtonListener),
+            new Button("Digital Down", GLFW.GLFW_GAMEPAD_BUTTON_DPAD_DOWN, defaultButtonListener),
+            new Button("Digital Right", GLFW.GLFW_GAMEPAD_BUTTON_DPAD_RIGHT, defaultButtonListener)
+        );
+
+        buttons = ReflectUtils.getAllObjects(ControllerInput.class, Button.class, this);
+        joysticks = ReflectUtils.getAllObjects(ControllerInput.class, Joystick.class, this);
+    }
+
+    public void moveCursor() {
+        double speed = 300 * Time.delta * (minecraft.gameSettings.controllerMenuSensitivity.value + 0.5f);
+
+        cursorX += ((Math.pow(joyLeft.getX(), 3.0f) + joyLeft.getX()) / 2.0f) * speed;
+        cursorY += ((Math.pow(joyLeft.getY(), 3.0f) + joyLeft.getY()) / 2.0f) * speed;
+
+        cursorX = Math.max(cursorX, 0);
+        cursorY = Math.max(cursorY, 0);
+
+        cursorX = Math.min(cursorX, minecraft.resolution.scaledWidth);
+        cursorY = Math.min(cursorY, minecraft.resolution.scaledHeight);
+    }
+
+    public GlfwGamepad getController() {
+        return controller;
+    }
+
+    public void update() {
+        if (disconnected || !controller.isPresent()) {
+            this.disconnected = true;
+            throw new RuntimeException("Controller Disconnected!");
+        }
+
+        for (int i = 0; i < buttons.length; i++) {
+            buttons[i].update();
+        }
+        for (int i = 0; i < joysticks.length; i++) {
+            joysticks[i].update();
+        }
+        digitalPad.update();
+    }
+
+    public Slot getSlotAtCursor(GuiContainer guiContainer) {
+        return getSlotAt((int) cursorX, (int) cursorY, guiContainer);
+    }
+
     public Slot getSlotAt(int x, int y, GuiContainer guiContainer) {
-		for(Slot slot : guiContainer.inventorySlots.inventorySlots) {
-			int mx = (int) cursorX;
-			int my = (int) cursorY;
-			
-			int slotX = (slot.xDisplayPosition + (minecraft.resolution.scaledWidth - guiContainer.xSize) / 2) - 2;
-			int slotY = (slot.yDisplayPosition + (minecraft.resolution.scaledHeight - guiContainer.ySize) / 2) - 2;
-			
-			if(mx > slotX && my > slotY && mx < slotX + 20 && my < slotY + 20) {
-				return slot;
-			}
-		}
-		return null;
+        for (Slot slot : guiContainer.inventorySlots.slots) {
+            int mx = (int) cursorX;
+            int my = (int) cursorY;
+
+            int slotX = (slot.x + (minecraft.resolution.scaledWidth - guiContainer.xSize) / 2) - 2;
+            int slotY = (slot.y + (minecraft.resolution.scaledHeight - guiContainer.ySize) / 2) - 2;
+
+            if (mx > slotX && my > slotY && mx < slotX + 20 && my < slotY + 20) {
+                return slot;
+            }
+        }
+        return null;
+    }
+
+    public void snapToSlot(GuiContainer guiContainer, int id) {
+        snapToSlot(guiContainer, guiContainer.inventorySlots.getSlot(id));
+    }
+
+    public void snapToSlot(GuiContainer guiContainer, Slot slot) {
+        if (slot == null) return;
+
+        int slotX = (slot.x + (minecraft.resolution.scaledWidth - guiContainer.xSize) / 2) - 1;
+        int slotY = (slot.y + (minecraft.resolution.scaledHeight - guiContainer.ySize) / 2) - 1;
+
+        //Snap to Slot
+        cursorX = slotX + 8;
+        cursorY = slotY + 8;
+    }
+
+    public void cancelButtonPresses() {
+        for (Button button : buttons) {
+            button.cancelButtonPress();
+        }
+    }
+
+    private String translateAxis(ControllerType controllerType, int axis) {
+        switch (axis) {
+            case GLFW.GLFW_GAMEPAD_AXIS_LEFT_X:
+            case GLFW.GLFW_GAMEPAD_AXIS_LEFT_Y:
+                return "Analog Left";
+            case GLFW.GLFW_GAMEPAD_AXIS_RIGHT_X:
+            case GLFW.GLFW_GAMEPAD_AXIS_RIGHT_Y:
+                return "Analog Right";
+            case GLFW.GLFW_GAMEPAD_AXIS_LEFT_TRIGGER:
+                switch (controllerType) {
+                    case PS3:
+                    case PS4:
+                    case PS5:
+                        return "L2";
+                    case NINTENDO_SWITCH_PRO:
+                        return "ZL";
+                    default:
+                        return "LT";
+                }
+            case GLFW.GLFW_GAMEPAD_AXIS_RIGHT_TRIGGER:
+                switch (controllerType) {
+                    case PS3:
+                    case PS4:
+                    case PS5:
+                        return "R2";
+                    case NINTENDO_SWITCH_PRO:
+                        return "ZR";
+                    default:
+                        return "RT";
+                }
+            default:
+                return "Axis " + axis;
+        }
+    }
+
+    private String translateBtn(ControllerType controllerType, int button) {
+        switch (button) {
+            case GLFW.GLFW_GAMEPAD_BUTTON_A:
+                switch (controllerType) {
+                    case PS3:
+                    case PS4:
+                    case PS5:
+                        return "X";
+                    case NINTENDO_SWITCH_PRO:
+                        return "B";
+                    default:
+                        return "A";
+                }
+            case GLFW.GLFW_GAMEPAD_BUTTON_B:
+                switch (controllerType) {
+                    case PS3:
+                    case PS4:
+                    case PS5:
+                        return "O";
+                    case NINTENDO_SWITCH_PRO:
+                        return "A";
+                    default:
+                        return "B";
+                }
+            case GLFW.GLFW_GAMEPAD_BUTTON_X:
+                switch (controllerType) {
+                    case PS3:
+                    case PS4:
+                    case PS5:
+                        return "□";
+                    case NINTENDO_SWITCH_PRO:
+                        return "Y";
+                    default:
+                        return "X";
+                }
+            case GLFW.GLFW_GAMEPAD_BUTTON_Y:
+                switch (controllerType) {
+                    case PS3:
+                    case PS4:
+                    case PS5:
+                        return "△";
+                    case NINTENDO_SWITCH_PRO:
+                        return "X";
+                    default:
+                        return "Y";
+                }
+            case GLFW.GLFW_GAMEPAD_BUTTON_BACK:
+                switch (controllerType) {
+                    case XBOXONE:
+                        return "View";
+                    case PS3:
+                        return "Select";
+                    case PS4:
+                    case PS5:
+                        return "Share";
+                    case NINTENDO_SWITCH_PRO:
+                        return "-";
+                    default:
+                        return "Back";
+                }
+            case GLFW.GLFW_GAMEPAD_BUTTON_START:
+                switch (controllerType) {
+                    case XBOXONE:
+                        return "Menu";
+                    case PS4:
+                    case PS5:
+                        return "Options";
+                    case NINTENDO_SWITCH_PRO:
+                        return "+";
+                    default:
+                        return "Start";
+                }
+            case GLFW.GLFW_GAMEPAD_BUTTON_LEFT_BUMPER:
+                switch (controllerType) {
+                    case PS3:
+                    case PS4:
+                    case PS5:
+                        return "L1";
+                    case NINTENDO_SWITCH_PRO:
+                        return "L";
+                    default:
+                        return "LB";
+                }
+            case GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_BUMPER:
+                switch (controllerType) {
+                    case PS3:
+                    case PS4:
+                    case PS5:
+                        return "R1";
+                    case NINTENDO_SWITCH_PRO:
+                        return "R";
+                    default:
+                        return "RB";
+                }
+            case GLFW.GLFW_GAMEPAD_BUTTON_LEFT_THUMB:
+                return "Left Stick";
+            case GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_THUMB:
+                return "Right Stick";
+            case GLFW.GLFW_GAMEPAD_BUTTON_DPAD_UP:
+                return "Digital Up";
+            case GLFW.GLFW_GAMEPAD_BUTTON_DPAD_DOWN:
+                return "Digital Down";
+            case GLFW.GLFW_GAMEPAD_BUTTON_DPAD_LEFT:
+                return "Digital Left";
+            case GLFW.GLFW_GAMEPAD_BUTTON_DPAD_RIGHT:
+                return "Digital Right";
+            default:
+                return "Button " + button;
+        }
     }
-	
-	public void snapToSlot(GuiContainer guiContainer, int id) {
-		snapToSlot(guiContainer, guiContainer.inventorySlots.getSlot(id));
-	}
-	
-	public void snapToSlot(GuiContainer guiContainer, Slot slot) {
-		if(slot == null) return;
-		
-		int slotX = (slot.xDisplayPosition + (minecraft.resolution.scaledWidth - guiContainer.xSize) / 2) - 1;
-		int slotY = (slot.yDisplayPosition + (minecraft.resolution.scaledHeight - guiContainer.ySize) / 2) - 1;
-		
-		//Snap to Slot
-		cursorX = slotX + 8;
-		cursorY = slotY + 8;
-	}
-	
-	private Component comp(String id) {
-		return InputHandler.getComponent(controller, id);
-	}
-	
-	public void cancelButtonPresses() {
-		for(Button button : buttons) {
-			button.cancelButtonPress();
-		}
-	}
-	
 }
diff --git a/src/main/java/net/minecraft/client/input/controller/ControllerInventoryHandler.java b/src/main/java/net/minecraft/client/input/controller/ControllerInventoryHandler.java
index fcded9beb..01ae1f0a8 100644
--- a/src/main/java/net/minecraft/client/input/controller/ControllerInventoryHandler.java
+++ b/src/main/java/net/minecraft/client/input/controller/ControllerInventoryHandler.java
@@ -21,18 +21,18 @@ public class ControllerInventoryHandler {
 		Slot slot = controllerInput.getSlotAtCursor(container);
 		
 		if(controllerInput.buttonA.pressedThisFrame()) {
-			for(Slot slot2 : container.inventorySlots.inventorySlots) {
-				System.out.println(slot2.id+": "+slot2.getStack());
+			for(Slot slot2 : container.inventorySlots.slots) {
+				System.out.println(slot2.index +": "+slot2.getItem());
 			}
 		}
 		
-		if(slot != null && isCraftingSlot.isTrue(slot) && slot.hasStack() && controllerInput.buttonA.isPressed()) {
+		if(slot != null && isCraftingSlot.isTrue(slot) && slot.hasItem() && controllerInput.buttonA.isPressed()) {
 			if(controllerInput.buttonA.getHoldTime() > 10 && controllerInput.buttonA.getHoldTime() % 2 == 1) {
 				click(container, 0);
 			}
 		}
 		
-		if(controllerInput.buttonZL.pressedThisFrame()) {
+		if(controllerInput.buttonLeftTrigger.pressedThisFrame()) {
 			if(slot != null) {
 				if(isCraftingSlot.isTrue(slot)) {
 					//Is in crafting field
@@ -42,14 +42,14 @@ public class ControllerInventoryHandler {
 						controllerInput.snapToSlot(container, invSlot); //Inventory Center
 					}
 				}else {
-					if(slot != null && slot.id > 9) lastSlot = slot;
+					if(slot != null && slot.index > 9) lastSlot = slot;
 					controllerInput.snapToSlot(container, craftingSlot); //Crafting Grid Center
 				}
 			}else {
 				controllerInput.snapToSlot(container, invSlot);
 			}
 		}
-		if(controllerInput.buttonZR.pressedThisFrame()) {
+		if(controllerInput.buttonRightTrigger.pressedThisFrame()) {
 			if(slot != null) {
 				if(isResultSlot.isTrue(slot)) {
 					if(lastSlot != null) {
@@ -68,15 +68,15 @@ public class ControllerInventoryHandler {
 	}
 	
 	public void handleCrafting(GuiCrafting crafting) {
-		handleAbstractCrafting(crafting, (e) -> e.id > 9, (e) -> e.id > 0 && e.id < 10, (e) -> e.id == 0, 5, 0, 24);
+		handleAbstractCrafting(crafting, (e) -> e.index > 9, (e) -> e.index > 0 && e.index < 10, (e) -> e.index == 0, 5, 0, 24);
 	}
 	
 	public void handleInventory(GuiInventory inventory) {
-		handleAbstractCrafting(inventory, (e) -> e.id >= 9 && e.id <= 44, (e) -> e.id >= 1 && e.id <= 4, (e) -> e.id == 0, 1, 0, 22);
+		handleAbstractCrafting(inventory, (e) -> e.index >= 9 && e.index <= 44, (e) -> e.index >= 1 && e.index <= 4, (e) -> e.index == 0, 1, 0, 22);
 	}
 	
 	public void handleFurnace(GuiFurnace furnace) {
-		handleAbstractCrafting(furnace, (e) -> e.id >= 3 && e.id <= 38, (e) -> e.id >= 0 && e.id <= 1, (e) -> e.id == 2, 0, 2, 16);
+		handleAbstractCrafting(furnace, (e) -> e.index >= 3 && e.index <= 38, (e) -> e.index >= 0 && e.index <= 1, (e) -> e.index == 2, 0, 2, 16);
 	}
 	
 	public void click(GuiContainer guiCrafting, int button) {
